import java.lang.*;
import java.util.*;
import java.awt.*;

class BooleanElement {

    private BooleanElement siblingA_;
    public BooleanElement siblingA() { return siblingA_; }
    public void siblingA(BooleanElement aBE) { siblingA_ = aBE; }

    private BooleanElement siblingB_;
    public BooleanElement siblingB() { return siblingB_; }
    public void siblingB(BooleanElement aBE) { siblingB_ = aBE; }

    private int outputState_;
    public int outputState() { return outputState_; }
    public void outputState(int theOS) { outputState_ = theOS; }

    private int intermediateState_;
    public int intermediateState() { return intermediateState_; }
    public void intermediateState(int theIS) { intermediateState_ = theIS; }

    private BitSet booleanRule_;
    public BitSet booleanRule() { return booleanRule_ ; }
    public void booleanRule(BitSet aRule) { booleanRule_ = aRule; }

    private Point gridLocation_;
    public Point gridLocation() { return gridLocation_; }
    public void gridLocation(Point aPoint) { gridLocation_ = aPoint; }

    BooleanElement() {
        this.initialize();
    }

    private void initialize() {
        this.outputState(0);
    }

    public void connectTo (BooleanElement e1, BooleanElement e2) {
        this.siblingA(e1);
        this.siblingB(e2);
    }

    public int computeIntermediateState() {
        int inputs = (this.siblingB().outputState() * 2) + this.siblingA().outputState();
        boolean result = this.booleanRule().get(inputs);
        if(result) {
            this.intermediateState(1);
            return 1;
        }
        this.intermediateState(0);
        return 0;
    }

}


